import { Component } from '@angular/core';
import { Headers, Http } from '@angular/http';

import { AppService } from './app.service';

import 'rxjs/Rx';

@Component({
  moduleId: module.id,
  selector: 'my-app',
  templateUrl: 'app.component.html',
  styleUrls: ['app.component.css'],
})

export class AppComponent {
  
  title = 'CData API Server Angular2 Demo';
  availableTables: string[] = [];
  selectedTable = '';
  
  availableColumns: string[]
  selectedColumns: string[];
  
  tableData: Object[];
  
  constructor(private appService: AppService) { }
  
  ngOnInit(): void {
    this.appService
      .getTables()
      .then( tables => { 
        for (let tableObj of tables) { 
          this.availableTables.push( tableObj.name ) 
        }
      });
  }
  
  tableChanged(): void {    
    this.appService
      .getColumns(this.selectedTable)
      .then( columns => this.availableColumns = columns );

    this.selectedColumns = [];
  }
  
  columnsChanged(): void {
    this.tableData = [];
  }
  
  dataButtonClicked(columnList: string): void {
    columnList = this.selectedColumns.join(',');
    this.appService
      .getTableData( this.selectedTable, columnList )
      .then( data => this.tableData = data );
  }
}
